<?php

/**
 * Frontend controllers extending from Shopware_Controllers_Frontend_Application do support the new backend components
 */
class Shopware_Controllers_Widgets_OfficialEkomiIntegration extends Enlight_Controller_Action
{

    /**
     * Product Identifiers.
     */
    const PRODUCT_IDENTIFIER_SKU = 'sku';
    const PRODUCT_IDENTIFIER_EAN = 'ean';

    /**
    * Shows the smart prc widget on product detail page.
    */
    public function smartPrcAction()
    {
        $pluginConfig = Shopware()->Plugins()->Backend()->OfficialEkomiIntegration()->Config();
        $this->View()->assign('isShowPrc', $pluginConfig['show-prc-widget']);
        $this->View()->assign('ekomiCustomerId', $pluginConfig['shop-id']);
        $this->View()->assign('ekomiWidgetToken', $pluginConfig['prc-widget-token']);
        if ($pluginConfig['product-identifier']== self::PRODUCT_IDENTIFIER_SKU) {
            $allChildSku = $this->getChildIdentifiers($this->Request()->getParam('articleID'), 'ordernumber');
            $this->View()->assign('ekomiProductIdentifier', $allChildSku);
        } else if ($pluginConfig['product-identifier']== self::PRODUCT_IDENTIFIER_EAN) {
            $allChildEan = $this->getChildIdentifiers($this->Request()->getParam('articleID'), 'ean');
            $this->View()->assign('ekomiProductIdentifier', $allChildEan);
        } else {
            $this->View()->assign('ekomiProductIdentifier', $this->Request()->getParam('articleID'));
        }
    }

    /**
     * Gets sku of all variants.
     *
     * @param int    $id
     * @param string $column
     *
     * @return string
     */
    protected function getChildIdentifiers($id, $column){
        $sql = "SELECT {$column} FROM s_articles_details WHERE {$column} != '' AND articleID = ?";
        $identifiers = Shopware()->Db()->fetchCol($sql, array($id));
        if (!empty($identifiers)) {
            return implode(',', $identifiers);
        }

        return '';
    }
}
